#define TRUE 1
#define FALSE 0

// framerate and timing
#define FPS 40
#define TICK_LAG (10/(FPS))

// flippable entity's sides
#define FRONT 1
#define BACK 0

// pixel size of the shapes icon
#define SHAPE_WIDTH 32
#define SHAPE_HEIGHT 32

// pixel size of a tile
#define TILE_WIDTH SHAPE_WIDTH
#define TILE_HEIGHT SHAPE_HEIGHT

// pixel size of entities
#define CARD_WIDTH 64
#define CARD_HEIGHT 96

#define PENCIL_WIDTH 16
#define PENCIL_HEIGHT 64

#define PAPER_WIDTH 96
#define PAPER_HEIGHT 96

// library inclusions
#include <kaiochao/shapes/shapes.dme>

// matrix shortcuts
#define size_matrix(x, y) matrix(x, 0, 0, 0, y, 0)
#define move_matrix(x, y) matrix(1, 0, x, 0, 1, y)
#define shear_matrix(x, y) matrix(1, x, 0, y, 1, 0)
#define shape_size(x, y) size_matrix(x / SHAPE_WIDTH, y / SHAPE_HEIGHT)

#define SHAPE(x, y) \
transform = shape_size(x, y); \
bound_width = x; \
bound_height = y; \
bound_x = (SHAPE_WIDTH - x) / 2; \
bound_y = (SHAPE_HEIGHT - y) / 2
