client
	var
		key_states[]
		key_down_time[]
		double_tap_period = 2.5

	New()
		. = ..()
		SetupKeyboard()

	proc
		SetupKeyboard()
			set waitfor = FALSE, background = TRUE

			var global/keys[]
			if(!keys)
				keys = new

				#ifndef KB_EXCLUDE_ARROWS
				keys.Add("north", "south", "east", "west")
				#endif

				#ifndef KB_EXCLUDE_MODIFIERS
				keys.Add("ctrl", "alt", "shift")
				#endif
				
				#ifndef KB_EXCLUDE_LETTERS
				for(var/n in text2ascii("a") to text2ascii("z")) keys += ascii2text(n)
				keys.Add("space", "return")
				#endif

				#ifndef KB_EXCLUDE_NUMBERS
				for(var/n in 0 to 9) keys += "[n]"
				#endif

			var macro = "macro"
			for(var/k in keys)
				var encoded = url_encode(lowertext(k))
				winset(src, "kdn_[encoded]", list2params(list(
					parent = macro,
					name = encoded,
					command = ".key-down \"[k]\"")))
				winset(src, "kup_[encoded]", list2params(list(
					parent = macro,
					name = "[encoded]+UP",
					command = ".key-up \"[k]\"")))

	verb
		key_down(K as text)
			set name = ".key down", instant = TRUE
			K = lowertext(K)
			if(!(key_states && key_states[K]))
				if(!key_states) key_states = new
				if(!key_down_time) key_down_time = new
				else if(world.time - key_down_time[K] < double_tap_period)
					DoubleTap(K)
				key_states[K] = TRUE
				key_down_time[K] = world.time
				KeyDown(K)

		key_up(K as text)
			set name = ".key up", instant = TRUE
			K = lowertext(K)
			if(key_states && key_states[K])
				key_states -= K
				key_states = key_states.len && key_states
				KeyUp(K)

	proc
		KeyDown(Key)

		KeyUp(Key) 

		DoubleTap(Key)

		IsKeyDown(Key)
			return Key && key_states && (key_states[lowertext(Key)])

		GetAxis(Positive, Negative)
			return IsKeyDown(Positive) - IsKeyDown(Negative)
