#ifndef TILE_WIDTH
#define TILE_WIDTH 32
#endif

#ifndef TILE_HEIGHT
#define TILE_HEIGHT 32
#endif

atom
	proc
		Width() return TILE_WIDTH
		Height() return TILE_HEIGHT
		Px(P) return 1 + (x - 1 + P)*TILE_WIDTH
		Py(P) return 1 + (y - 1 + P)*TILE_HEIGHT
		Cx() return Px(1/2)
		Cy() return Py(1/2)

	movable
		Width() return bound_width
		Height() return bound_height
		Px(P) return 1 + bound_x + step_x + (x-1)*TILE_WIDTH + P*bound_width
		Py(P) return 1 + bound_y + step_y + (y-1)*TILE_HEIGHT + P*bound_height

		proc
			SetLoc(Loc, StepX, StepY)
				loc = Loc
				step_x = StepX
				step_y = StepY

			SetPosition(Px, Py, Z)
				SetLoc(
					Loc = locate(1 + (Px-1)/TILE_WIDTH, 1 + (Py-1)/TILE_HEIGHT, Z),
					StepX = (Px-1) % TILE_WIDTH - bound_x,
					StepY = (Py-1) % TILE_HEIGHT - bound_y)

			SetCenter(Cx, Cy, Z)
				SetPosition(Cx - Width()/2, Cy - Height()/2, Z)
