entity/card
	parent_type = /entity/flippable

	icon_state = "rect"
	SHAPE(CARD_WIDTH, CARD_HEIGHT)
	color = "gray"

	can_set_icon = TRUE

	New()
		..()
		physics.friction = 0.1
		front_color = rgb(rand(255), rand(255), rand(255))
		color = front_color

entity/flippable
	var side = FRONT
	var flip_time = 1
	var can_set_icon = FALSE

	var matrix/shape
	var image/face
	var image/front
	var image/back

	var front_color
	var back_color = "gray"
	var can_recolor = TRUE

	New()
		..()
		shape = shape || initial(transform)

	Click(location, control, params)
		..()
		params2list(params)["right"] && Flip()

	MouseDown(location, control, params)
		if(can_set_icon && params2list(params)["middle"])
			IconOptions(usr.client)
		else ..()

	Dragged()
		can_set_icon && dragger.IsKeyDown("i") && IconOptions(usr.client)
		can_recolor && dragger.IsKeyDown("r") && Recolor(dragger)
		..()

	proc/Recolor(client/C)
		var new_color = input(C, "", "Recolor [src]", color) as null|color
		if(!isnull(new_color))
			if(side)
				front_color = new_color
			else back_color = new_color
			color = new_color

	proc/IconOptions(client/C)
		var choice = !(side ? front : back) && "Change" || alert(C, "The [src] has an icon.", "Option", "Clear", "Change", "Cancel")
		switch(choice)
			if("Clear")
				SetIcon(side, null)
			if("Change")
				var new_icon = input(C, "") as null|icon
				if(new_icon)
					SetIcon(side, new_icon)

	proc/SetSide(Side)
		overlays -= side ? front : back

		side = Side

		color = side ? front_color : back_color
		if(side)
			if(front)
				overlays += front
		else
			if(back)
				overlays += back

	proc/SetIcon(Side, IconFile)
		if(Side)
			overlays -= front
			if(IconFile)
				front = image(IconFile, "front", layer = FLOAT_LAYER)
			else front = null
		else
			overlays -= back
			if(IconFile)
				back = image(IconFile, "back", layer = FLOAT_LAYER)
			else back = null

		if(IconFile)
			var icon/i = icon(IconFile)
			var width = i.Width(), height = i.Height()
			face = side ? front : back
			face.pixel_x = (SHAPE_WIDTH - width) / 2
			face.pixel_y = (SHAPE_HEIGHT - height) / 2
			face.transform = size_matrix(SHAPE_WIDTH / width, SHAPE_HEIGHT / height)

		SetSide(side)

	proc/Flip()
		var matrix/a = turn(shape, angle)
		var matrix/b = new (shape)
		b.Scale(0, 1)
		b.Turn(angle)
		animate(src, time = 0, transform = transform)
		animate(time = flip_time, transform = b)
		animate(time = flip_time, transform = a)
		sleep flip_time
		SetSide(!side)
