entity/card
	DragStop()
		..()
		var nearby[0]

		var ax = Cx()
		var ay = Cy()
		for(var/entity/e in obounds())
			var dx = e.Cx() - ax
			var dy = e.Cy() - ay
			var d = max(abs(dx), abs(dy))
			if(d <= 16)
				nearby += e

		var entity/deck/deck = locate() in nearby
		if(deck)
			deck.Push(src)
		else
			var entity/card/card = locate() in nearby
			if(card)
				deck = new
				deck.FormStack(card, src)

entity/deck
	layers_special = TRUE

	var entity/card/cards[0]
	var image/stack_overlay

	Click(location, control, params)
		if(params2list(params)["right"])
			Pop()
		..()

	DragStop()
		..()
		var nearby[0]

		var ax = Cx()
		var ay = Cy()
		for(var/entity/e in obounds())
			var dx = e.Cx() - ax
			var dy = e.Cy() - ay
			var d = max(abs(dx), abs(dy))
			if(d <= 16)
				nearby += e

		var entity/deck/deck = locate() in nearby
		if(deck)
			deck.cards += cards
			deck.UpdateStackAppearance()
			loc = null
		else
			var entity/card/card = locate() in nearby
			if(card)
				cards.Insert(1, card)
				UpdateStackAppearance()

	proc/FormStack(entity/card/Bottom, entity/card/Top)
		loc = Bottom.loc
		step_x = Bottom.step_x
		step_y = Bottom.step_y
		Push(Bottom)
		Push(Top)

	proc/Push(entity/card/Card)
		cards += Card
		UpdateStackAppearance()

	proc/Pop()
		var entity/card/card = cards[cards.len]
		cards.len--
		SeparateCard(card)
		UpdateStackAppearance()
		return card

	proc/SeparateCard(entity/card/Card)
		Card.loc = loc
		Card.step_x = step_x
		Card.step_y = step_y + 16
		Card.PushToTop()

		var speed = rand(4, 8)
		var angle = rand(360)
		Card.physics.velocity_x = sin(angle) * speed
		Card.physics.velocity_y = cos(angle) * speed

		if(cards.len == 1)
			Pop()

	proc/UpdateStackAppearance()
		if(!cards.len)
			loc = null
		else
			overlays -= stack_overlay
			stack_overlay = image(layer = FLOAT_LAYER)
			for(var/n in 1 to cards.len)
				var entity/card/card = cards[n]
				card.loc = src
				card.layer = n - cards.len - 5
				var py = card.pixel_y
				card.pixel_y = n * 2
				stack_overlay.overlays += card
				card.pixel_y = py
			overlays += stack_overlay
