client
	// called every frame while dragging
	proc/Dragged(entity/Dragging, MoveX, MoveY)
		Dragging.Dragged(MoveX, MoveY)

entity
	// can this entity be moved around by dragging it with the mouse?
	var draggable = TRUE
	var rotatable = TRUE
	var throw_speed = 10

	var tmp/client/dragger

	var angle = 0

	MouseDown(location, control, params)
		if(draggable && !dragger && params2list(params)["left"])
			DragStart(usr.client)

	MouseUp(location, control, params)
		if(dragger == usr.client && params2list(params)["left"])
			DragStop()

	MouseDrop(over_object, src_location, over_location, src_control, over_control, params)
		if(dragger == usr.client && params2list(params)["left"])
			DragStop()

	// called by dragger.Dragged() every frame this draggable is being dragged
	proc/Dragged(MoveX, MoveY)
		layers_special && PushToTop()

		if(rotatable && dragger)
			var turn_input = dragger.GetAxis("e", "q") * 5
			if(turn_input)
				angle += turn_input
				transform = turn(initial(transform), angle)
				Rotated(turn_input)

	proc/Rotated(Degrees)

	// called if stopped dragging with speed
	proc/Thrown()

	proc/DragStop()
		has_shadow && HideShadow()

		dragger = null

		if(physics)
			physics.enabled = TRUE

			if(physics.SqrSpeed() > throw_speed)
				Thrown()

	proc/DragStart(Dragger)
		set waitfor = FALSE

		dragger = Dragger

		has_shadow && ShowShadow()

		var last_x = dragger.mouse.x
		var last_y = dragger.mouse.y

		while(dragger == usr.client)
			var move_x = dragger.mouse.x - last_x
			var move_y = dragger.mouse.y - last_y

			last_x = dragger.mouse.x
			last_y = dragger.mouse.y

			if(move_x || move_y)
				Translate(move_x, move_y)

			if(physics)
				physics.enabled = FALSE
				physics.velocity_x = move_x
				physics.velocity_y = move_y

			dragger.Dragged(src, move_x, move_y)

			sleep TICK_LAG
