entity/paper
	parent_type = /entity/flippable

	icon_state = "rect"
	color = "white"
	back_color = "white"

	SHAPE(PAPER_WIDTH, PAPER_HEIGHT)

	rotatable = TRUE
	can_set_icon = TRUE

	var front_pixels[0]
	var back_pixels[0]

	Dragged()
		..()
		if(dragger && dragger.IsKeyDown("c") && "Clear" == alert(dragger, "Clear the page?", "Clear", "Clear", "Cancel"))
			if(side)
				overlays -= front_pixels
				front_pixels.len = 0
			else
				overlays -= back_pixels
				back_pixels.len = 0

	SetSide(Side)
		overlays -= side ? front_pixels : back_pixels
		..()
		overlays += side ? front_pixels : back_pixels

	proc/DrawGlobalPoint(X, Y, Color)
		return DrawPoint(X - Px(), Y - Py(), Color)

	proc/DrawPoint(X, Y, Color)
		var matrix/pm = move_matrix(X, Y)
		pm.Translate(bound_width/-2, bound_height/-2)
		pm.Turn(-angle)
		pm.Translate(bound_width/2, bound_height/2)

		if(!((pm.c in 0 to bound_width+1) && (pm.f in 0 to bound_height+1)))
			return

		var obj/pixel/p = new
		var matrix/m = initial(p.transform)
		m.Translate(X - bound_width / 2, Y - bound_height / 2)
		m *= ~transform
		p.transform = m
		p.color = Color
		overlays += p

		if(side)
			front_pixels += p
		else back_pixels += p

		return TRUE

obj/pixel
	icon_state = "oval"
	color = "black"
	alpha = 64
	transform = size_matrix(4/SHAPE_WIDTH, 4/SHAPE_HEIGHT)
	layer = FLOAT_LAYER
	appearance_flags = RESET_COLOR
