entity/pencil
	layer = 10

	overlays = list(/entity/pencil/shaft)
	underlays = list(/entity/pencil/tip)

	shaft
		parent_type = /obj
		icon_state = "rect"
		color = "white"
		SHAPE(PENCIL_WIDTH, PENCIL_HEIGHT)
		layer = FLOAT_LAYER

	tip
		parent_type = /obj
		icon_state = "arrow"
		color = "silver"
		transform = matrix(0.5, 0, 0, 0, -0.8, -32)
		layer = FLOAT_LAYER

	var tip_x, tip_y
	var last_tip_x
	var last_tip_y
	var drawing

	Move()
		. = ..()
		if(.)
			UpdateTipPosition()

	Dragged()
		if(dragger.mouse.buttons & MOUSE_RIGHT || dragger.IsKeyDown("space"))
			Draw()
		else
			drawing = FALSE

		if(dragger.IsKeyDown("r"))
			color = input(dragger, "", "[src] color", color) as color

		..()

	Rotated()
		UpdateTipPosition()

	proc/UpdateTipPosition()
		tip_x = Cx() - 46 * sin(angle)
		tip_y = Cy() - 46 * cos(angle)

	proc/Draw()
		var dx = tip_x - last_tip_x
		var dy = tip_y - last_tip_y
		last_tip_x = tip_x
		last_tip_y = tip_y
		if(drawing && (dx || dy))
			var d = sqrt(dx*dx + dy*dy)
			var ux = dx / d
			var uy = dy / d
			for(var/n in 0 to d step 4)
				DrawPoint(tip_x - ux * n, tip_y - uy * n)
		else
			drawing = TRUE
			DrawPoint(tip_x, tip_y)

	proc/DrawPoint(X, Y)
		var bounds[] = bounds(X - 64, Y - 64, 128, 128, z)
		var entities[] = layering_entities & bounds
		for(var/i in entities.len to 1 step -1)
			var entity/paper/p = entities[i]
			if(istype(p) && p.DrawGlobalPoint(X, Y, color))
				break
